#include <Performer/pf/pfLayer.h>
#include <ygNetMessages.h>
#include "layer.h"

using namespace std;

extern "C" ygNode* construct_layer(const char* name,bool master) { return new layer(name,master); }

struct _layerPrivateData
    {
    pfLayer* layer;
    int mode;
    };

layer::layer(const char* name,bool master) : ygNode(name,master,false)
    {
    setClassName("layer",true);
    p_ = new struct _layerPrivateData;
    p_->layer = new pfLayer;
    p_->mode = PFDECAL_BASE_FAST;
    setMode(p_->mode);
    setPfNode(p_->layer);
    addNetMessage("mode",&p_->mode,YG_NET_INT);
    addNetMessageMap("mode","fast",PFDECAL_BASE_FAST);
    addNetMessageMap("mode","quality",PFDECAL_BASE_HIGH_QUALITY);
    addNetMessageMap("mode","stencil",PFDECAL_BASE_STENCIL);
    addNetMessageMap("mode","displace",PFDECAL_BASE_DISPLACE);
    addNetMessageMap("mode","offset",PFDECAL_BASE_DISPLACE | PFDECAL_LAYER_OFFSET);
    }

layer::~layer(void)
    {
    delete p_;
    }


void layer::reset(void)
    {
    resetNetMessage("mode");
    setMode(p_->mode);
    ygNode::reset();
    }


void layer::message(const ygMessage& msg)
    {
    if (msg == "mode")
        {
        setMode(p_->mode);
        }
    else
        ygNode::message(msg);
    }


void layer::setMode(int val)
    {
    p_->mode = val;
    p_->layer->setMode(val);
    }
